class grid {
  int gWidth;
  int gHeight;
  Box[][] boxes;
  float xTrans;
  float yTrans;
  float dirAct;
  float dirTar;
  float dirTurn;
  float speed;
  
  grid () {
    gWidth = (int)(width / boxSize + 1);
    gHeight = (int)(height / boxSize + 1);
    boxes = new Box[gWidth][gHeight];
    xTrans = 1000;
    yTrans = 1000;
    dirAct = 0;
    dirTar = 0;
    dirTurn = 0.2;
    speed = 1;
  }
  
  void generate () {
    noiseSeed(seed);
    for (int j = 0; j < gHeight; j++)
      for (int i = 0; i < gWidth; i++) {
        boxes[i][j] = new Box();
        boxes[i][j].x = i;
        boxes[i][j].y = j;
        float n = noise((i + xTrans) * gWidth * 0.0005, (j + yTrans) * gHeight * 0.0005);
        if (n < 0.4)
          n = c1;
        else if (n < 0.5)
            n = c2;
          else 
              n = c3;
        boxes[i][j].c = (int)n;
    }
  }
  
  void trans () {
    dirTurn = 0.02;
    if (abs(dirTar - dirAct) < dirTurn && 0 == (int) random(10)) {
      dirTar = random(0, 6.28);
      int rand = (int) random(100);
      c1 += rand;
      c2 += rand;
      c3 += rand;
      if (dirTar - dirAct > 3.14) 
        dirAct += 6.28;
      if (dirAct - dirTar > 3.14)
        dirAct -= 6.28;
    }
    
    if (dirTar > dirAct)
      dirAct += dirTurn;
    else
      dirAct -= dirTurn;
    
    speed = 1.00;
    xTrans += speed * sin(dirAct);
    yTrans += speed * cos(dirAct);
  }
  
  void gDraw () {
    generate();
    noiseSeed(seed);
    for (int j = gHeight - 1 ; j >= 0; j--)
      for (int i = gWidth - 1; i >= 0; i--) {
        boxes[i][j].show();
      }
    trans();
  }
}